<template>
  <MainTemplate>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Auszeichnungen</h1>
      </div>
    </template>
    <template #diffMain>
      <div class="flex flex-col gap-4 h-full pl-7">
        <div class="flex flex-col gap-2 grow overflow-y-scroll pr-7">
          <AwardListItem v-for="award in awards" :key="award.id" :award="award" />
        </div>
        <div class="flex flex-row gap-4">
          <button v-if="can('create', 'settings', 'award')" primary class="!w-fit" @click="openCreateModal">
            Auszeichnung erstellen
          </button>
        </div>
      </div>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineComponent, defineAsyncComponent, markRaw } from "vue";
import { mapState, mapActions } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import { useAwardStore } from "@/stores/admin/settings/award";
import AwardListItem from "@/components/admin/settings/award/AwardListItem.vue";
import { useModalStore } from "@/stores/modal";
import { useAbilityStore } from "@/stores/ability";
</script>

<script lang="ts">
export default defineComponent({
  computed: {
    ...mapState(useAwardStore, ["awards"]),
    ...mapState(useAbilityStore, ["can"]),
  },
  mounted() {
    this.fetchAwards();
  },
  methods: {
    ...mapActions(useAwardStore, ["fetchAwards"]),
    ...mapActions(useModalStore, ["openModal"]),
    openCreateModal() {
      this.openModal(
        markRaw(defineAsyncComponent(() => import("@/components/admin/settings/award/CreateAwardModal.vue")))
      );
    },
  },
});
</script>
